/*** ESCONDID.C ***/

#include "bresenha.c"

/* ----------------------------------------------------------------------- */

void Preenche(int cor, int cor_secundaria, int padrao) {

/* Preenche a regiao delitada pela matriz de pontos p[]. Sao usadas duas
   cores de preenchimento misturadas segundo o padrao de bits indicado. */

  int teste, cont = 0, i, a0, b0, a1, b1, m, M, linha, col;

  a0 = 10000; a1 = -10000;
  b0 = 10000; b1 = -10000;
  for (i = 0; i < quant_pontos; i++) {
   if (a0 > p[i].x) a0 = p[i].x;
   if (b0 > p[i].y) b0 = p[i].y;
   if (a1 < p[i].x) a1 = p[i].x;
   if (b1 < p[i].y) b1 = p[i].y;
  }

  for (linha = b0; linha <= b1; linha++) {
    m = 10000; M = -10000;
    for (i = 0; i < quant_pontos; i++)
      if (linha == p[i].y) {
	if (m > p[i].x) m = p[i].x;
	if (M < p[i].x) M = p[i].x;
      }
    for (col = m; col <= M; col++) {
      cont++;
      cont %= 8;
      teste = padrao >> cont;
      if (teste & 1)
	putpixel(col, linha, cor);
      else
	putpixel(col, linha, cor_secundaria);
    }
  }
}

/* ----------------------------------------------------------------------- */

void DeterminaPontos(int a, int b, int c, int d, int e, int f) {

  quant_pontos = 0;
  SequenciaDePontosDaReta(a, b, c, d);
  SequenciaDePontosDaReta(c, d, e, f);
  SequenciaDePontosDaReta(a, b, e, f);
  if (quant_pontos > MAX_PONTOS) return;
}

/* ----------------------------------------------------------------------- */

void Pintar(int a, int b, int c, int d, int e, int f, int g, int h,
	    int cor_front, int cor_int1, int cor_int2, int padrao) {

/* Pinta a regiao (a, b) - (c, d) - (e, f) - (g, h). A fronteira e' pintada
   com  a cor cor_front. O interior  e' pintado  com  as cores  cor_int1  e
   cor_int2 misturadas conforme os bits do parametro padrao. */

  DeterminaPontos(a, b, c, d, e, f);
  Preenche(cor_int1, cor_int2, padrao);
  DeterminaPontos(a, b, e, f, g, h);
  Preenche(cor_int1, cor_int2, padrao);
  setcolor(cor_front);
  line(a, b, c, d);
  line(c, d, e, f);
  line(e, f, g, h);
  line(g, h, a, b);
}

/* ----------------------------------------------------------------------- */

void Pintar2(int a, int b, int c, int d, int e, int f, int g, int h,
	    int cor_front, int cor_int1, int cor_int2, int N) {

/* Pinta a regiao (a, b) - (c, d) - (e, f) - (g, h). A fronteira e' pintada
   com a cor cor_front. O interior e' pintado com o numero de cor N. */

  int padrao;

  if (N <= 0) padrao = 1;
  else if (N > 0 && N <= 1) padrao = 17;
  else if (N > 1 && N <= 2) padrao = 5;
  else if (N > 2 && N <= 3) padrao = 3;
  else if (N > 3 && N <= 4) padrao = 73;
  else if (N > 4 && N <= 5) padrao = 21;
  else if (N > 5 && N <= 6) padrao = 7;
  else if (N > 6 && N <= 7) padrao = 85;
  else if (N > 7 && N <= 8) padrao = 153;
  else if (N > 8 && N <= 9) padrao = 99;
  else if (N > 9 && N <= 10) padrao = 51;
  else if (N > 10 && N <= 11) padrao = 27;
  else if (N > 11 && N <= 12) padrao = 15;
  else if (N > 12 && N <= 13) padrao = 213;
  else if (N > 13 && N <= 14) padrao = 109;
  else if (N > 14 && N <= 15) padrao = 219;
  else if (N > 15 && N <= 16) padrao = 231;
  else if (N > 16) padrao = 255;

  DeterminaPontos(a, b, c, d, e, f);
  Preenche(cor_int1, cor_int2, padrao);
  DeterminaPontos(a, b, e, f, g, h);
  Preenche(cor_int1, cor_int2, padrao);
  setcolor(cor_front);
  line(a, b, c, d);
  line(c, d, e, f);
  line(e, f, g, h);
  line(g, h, a, b);
}

/* ----------------------------------------------------------------------- */

#define D_OBS(X, Y, Z)  sqrt(SQR(X - o1*dist_obs) + SQR(Y - o2*dist_obs) \
			   + SQR(Z - o3*dist_obs))

float DistanciaObs(float xp1, float yp1, float zp1,
		   float xp2, float yp2, float zp2,
		   float xp3, float yp3, float zp3,
		   float xp4, float yp4, float zp4) {

/* Calcula a distancia media do observador `a regiao (xp1, yp1, zp1) -
   (xp2, yp2, zp2) - (xp3, yp3, zp3) - (xp4, yp4, zp4) */
  float d1, d2, d3, d4, D1, D2, D3;

  D1 = o1*dist_obs; D2 = o2*dist_obs; D3 = o3*dist_obs;
  d1 =  sqrt(SQR(xp1 - D1) + SQR(yp1 - D2) + SQR(zp1 - D3));
  d2 =  sqrt(SQR(xp2 - D1) + SQR(yp2 - D2) + SQR(zp2 - D3));
  d3 =  sqrt(SQR(xp3 - D1) + SQR(yp3 - D2) + SQR(zp3 - D3));
  d4 =  sqrt(SQR(xp4 - D1) + SQR(yp4 - D2) + SQR(zp4 - D3));

  return (d1 + d2 + d3 + d4)/4.0;
}

/* ------------------------------------------------------------------------- */

typedef struct {
  float d;                  /* Distancia do observador `a media dos vertices */
  int xq1, yq1, xq2, yq2, xq3, yq3, xq4, yq4;  /* Vertices                   */
  float cosN; /* Cosseno do angulo entre os vetores normal e o do observador */
  int n;                    /* Numero do grafico                             */
} t_regiao;

/* ------------------------------------------------------------------------- */

void LeRegiao(FILE *arq, long n, t_regiao *Regiao) {

/* Le regiao no arquivo arq. A primeira regiao e' a de ordem 0. */

  fseek(arq, sizeof(t_regiao)*n, SEEK_SET);
  fread(Regiao, sizeof(t_regiao), 1, arq);
};

/* ------------------------------------------------------------------------- */

long QuantasRegioes(char *nome_arq) {

/* Determina quantas regioes foram gravadas no arquivo com nome nome_arq */

  struct ffblk x;

  findfirst(nome_arq, &x, 0);
  return x.ff_fsize/sizeof(t_regiao);
}

/* ------------------------------------------------------------------------- */

float LeDistanciaEmArquivo(FILE *arq, long rec) {

  t_regiao Regiao;

  fseek(arq, rec*sizeof(t_regiao), SEEK_SET);
  if (fread(&Regiao, sizeof(t_regiao), 1, arq))
    return Regiao.d;
  else
    return NULL;
}

/* ------------------------------------------------------------------------- */

void TrocaItensEmArquivo(FILE *arq, long i, long j) {

  /* Troca os itens de ordens i e j no arquivo arq */

  char a[sizeof(t_regiao)], b[sizeof(t_regiao)];

  fseek(arq, sizeof(t_regiao)*i, SEEK_SET);
  fread(a, sizeof(t_regiao), 1, arq);
  fseek(arq, sizeof(t_regiao)*j, SEEK_SET);
  fread(b, sizeof(t_regiao), 1, arq);

  fseek(arq, sizeof(t_regiao)*j, SEEK_SET);
  fwrite(a, sizeof(t_regiao), 1, arq);
  fseek(arq, sizeof(t_regiao)*i, SEEK_SET);
  fwrite(b, sizeof(t_regiao), 1, arq);
}

/* ------------------------------------------------------------------------- */

void qs_disco(FILE *arq, long esquerda, long direita) {

  /* Classifica o arquivo arq, colocando em ordem crescente os campos
     distancia */

  long i, j;
  float x;

  i = esquerda; j = direita;
  x = LeDistanciaEmArquivo(arq, (i + j)/2);

  do {
    while (LeDistanciaEmArquivo(arq, i) < x && i < direita) i++;
    while (LeDistanciaEmArquivo(arq, j) > x && j > esquerda) j--;
    if (i <= j) {
      TrocaItensEmArquivo(arq, i, j);
      i++; j--;
    }
  } while (i <= j);
  if (esquerda < j) qs_disco(arq, esquerda, j);
  if (i < direita) qs_disco(arq, i, direita);
}

/* ------------------------------------------------------------------------- */

void ClassificaRegioes(FILE *arq, char *nome_arq) {

  long quant;

  quant = QuantasRegioes(nome_arq);
  qs_disco(arq, 0, quant - 1);
}

/* ------------------------------------------------------------------------- */

void ArestaDoCubo(float a, float b, float c,
		  float d, float e, float f, int cor) {

  int X1, Y1, X2, Y2;
  float p1, p2;

  setcolor(cor);
  ProjetaPonto(a, b, c, &p1, &p2);
  X1 = (int) (A + p1*TAM);
  Y1 = (int) (B - p2*TAM);
  ProjetaPonto(d, e, f, &p1, &p2);
  X2 = (int) (A + p1*TAM);
  Y2 = (int) (B - p2*TAM);
  line(X1, Y1, X2, Y2);
}

/* ------------------------------------------------------------------------- */

#define PADRAO(x)      ((int) 255.0*(1.0 + x)/2.0)
#define PADRAO2(x)     ((int) 255.0*acos(x)/M_PI)
#define PADRAODECOR(x) ((int) 15.0*(1.0 + x)/2.0)

/* ------------------------------------------------------------------------- */

int DesenhaSuperficieEsc(float (*f1) (float,float), float (*f2)(float, float),
  float (*f3)(float, float), float umin, float umax, float vmin, float vmax,
  float *xmin, float *xmax, float *ymin, float *ymax, float *zmin, float *zmax,
  int cor_f1, int cor_f2, int cor_int1, int cor_int2, int cor_int3,
  int cor_int4, int padrao1, int padrao2, char *NomeArquivo, int opcao) {

/* Desenha a superficie (f1, f2, f3). As  superficies  invisiveis sao apagadas.
   A parte superior da superficie e' pintada com  a  cor de  fronteira cor_f1 e
   cores cor_int1 e cor_int2 misturadas conforme  o  padrao  de  bits  padrao1.
   A parte inferior da superficie e' pintada com a cor de  fronteira  cor_f2  e
   cores cor_int3 e cor_int4  misturadas conforme  o  padrao  de  bits padrao2.
   Se padrao1 for negativo, entao  os  padroes  fornecidos  serao  recalculados
   em  funcao  do angulo  entre o vetor observador e o vetor normal ao grafico.
   E'  necessario  algum  espaco  livre  no  disco  para  a criacao do  arquivo
   NomeArquivo.  Se  opcao  for  maior  ou igual  a  0,  e' desenhado  um  cubo
   envolvendo a superficie desenhada. Nos parametros *xmin, *max, *ymin, *ymax,
   *zmin, *zmax sao devolvidos os valores maximos e minimos de x, y, z. Retorna
   -1 em caso de erro. */

  float u, v, xp1, yp1, zp1, xp2, yp2, zp2, xp3, yp3, zp3, xp4, yp4, zp4,
	X, Y, distancia, n1, n2, n3, smax, s1, s2, s3, s4, s5, s6, s7, s8;
  int k = 0, xq1, xq2, xq3, xq4, yq1, yq2, yq3, yq4;
  t_regiao re;
  long i, quant;
  FILE *arq;
  char arq_dados[80];

  strcpy(arq_dados, NomeArquivo);
  while(arq_dados[k] != '\0' && arq_dados[k] != '.') k++;
  arq_dados[k] = '\0';
  strcat(arq_dados, ".DAT");
  if ((arq = fopen(arq_dados, "wb")) == NULL) return -1;

  *xmax = *xmin = f1(umin, vmin);
  *ymax = *ymin = f2(umin, vmin);
  *zmax = *zmin = f3(umin, vmin);

  for (u = umin + (umax - umin)/nu; u <= umax + (umax - umin)/(2*nu);
						       u += (umax - umin)/nu)
    for (v = vmin + (vmax - vmin)/nv; v <= vmax + (vmax - vmin)/(2*nv);
						       v += (vmax - vmin)/nv) {
      xp1 = f1(u, v);
      yp1 = f2(u, v);
      zp1 = f3(u, v);
      if (*xmax < xp1) *xmax = xp1;
      if (*xmin > xp1) *xmin = xp1;
      if (*ymax < yp1) *ymax = yp1;
      if (*ymin > yp1) *ymin = yp1;
      if (*zmax < zp1) *zmax = zp1;
      if (*zmin > zp1) *zmin = zp1;

      xp2 = f1(u - (umax - umin)/nu, v);
      yp2 = f2(u - (umax - umin)/nu, v);
      zp2 = f3(u - (umax - umin)/nu, v);
      if (*xmax < xp2) *xmax = xp2;
      if (*xmin > xp2) *xmin = xp2;
      if (*ymax < yp2) *ymax = yp2;
      if (*ymin > yp2) *ymin = yp2;
      if (*zmax < zp2) *zmax = zp2;
      if (*zmin > zp2) *zmin = zp2;

      xp3 = f1(u, v - (vmax - vmin)/nv);
      yp3 = f2(u, v - (vmax - vmin)/nv);
      zp3 = f3(u, v - (vmax - vmin)/nv);
      if (*xmax < xp3) *xmax = xp3;
      if (*xmin > xp3) *xmin = xp3;
      if (*ymax < yp3) *ymax = yp3;
      if (*ymin > yp3) *ymin = yp3;
      if (*zmax < zp3) *zmax = zp3;
      if (*zmin > zp3) *zmin = zp3;

      xp4 = f1(u - (umax - umin)/nu, v - (vmax - vmin)/nv);
      yp4 = f2(u - (umax - umin)/nu, v - (vmax - vmin)/nv);
      zp4 = f3(u - (umax - umin)/nu, v - (vmax - vmin)/nv);
      if (*xmax < xp4) *xmax = xp4;
      if (*xmin > xp4) *xmin = xp4;
      if (*ymax < yp4) *ymax = yp4;
      if (*ymin > yp4) *ymin = yp4;
      if (*zmax < zp4) *zmax = zp4;
      if (*zmin > zp4) *zmin = zp4;

      ProjetaPonto(xp1, yp1, zp1, &X, &Y);
      xq1 = (int) (A + X*TAM); yq1 = (int) (B - Y*TAM);
      ProjetaPonto(xp2, yp2, zp2, &X, &Y);
      xq2 = (int) (A + X*TAM); yq2 = (int) (B - Y*TAM);
      ProjetaPonto(xp3, yp3, zp3, &X, &Y);
      xq3 = (int) (A + X*TAM); yq3 = (int) (B - Y*TAM);
      ProjetaPonto(xp4, yp4, zp4, &X, &Y);
      xq4 = (int) (A + X*TAM); yq4 = (int) (B - Y*TAM);

      FechoConvexo(&xq1, &yq1, &xq2, &yq2, &xq3, &yq3, &xq4, &yq4);
      distancia = DistanciaObs(xp1, yp1, zp1, xp2, yp2, zp2,
			       xp3, yp3, zp3, xp4, yp4, zp4);
      VetorNormal(&n1, &n2, &n3, f1, f2, f3, u - (umax - umin)/(2*nu),
					     v - (vmax - vmin)/(2*nv));
      re.cosN = (n1*o1 + n2*o2 + n3*o3)/NORMA(n1, n2, n3);

      re.d = distancia;
      re.xq1 = xq1;
      re.yq1 = yq1;
      re.xq2 = xq2;
      re.yq2 = yq2;
      re.xq3 = xq3;
      re.yq3 = yq3;
      re.xq4 = xq4;
      re.yq4 = yq4;
      re.n = 1;
      fwrite(&re, sizeof(t_regiao), 1, arq);
    }

  fclose(arq);

  if ((arq = fopen(arq_dados, "r+b")) == NULL) return -1;
  ClassificaRegioes(arq, arq_dados);

  smax = s1 = D_OBS(*xmin, *ymin, *zmin);
  s2 = D_OBS(*xmin, *ymin, *zmax);
  if (smax < s2) smax = s2;
  s3 = D_OBS(*xmin, *ymax, *zmin);
  if (smax < s3) smax = s3;
  s4 = D_OBS(*xmin, *ymax, *zmax);
  if (smax < s4) smax = s4;
  s5 = D_OBS(*xmax, *ymin, *zmin);
  if (smax < s5) smax = s5;
  s6 = D_OBS(*xmax, *ymin, *zmax);
  if (smax < s6) smax = s6;
  s7 = D_OBS(*xmax, *ymax, *zmin);
  if (smax < s7) smax = s7;
  s8 = D_OBS(*xmax, *ymax, *zmax);
  if (smax < s8) smax = s8;

  if (opcao >= 0) {
    ArestaDoCubo(*xmin, *ymin, *zmin, *xmax, *ymin, *zmin, opcao);
    ArestaDoCubo(*xmin, *ymin, *zmin, *xmin, *ymax, *zmin, opcao);
    ArestaDoCubo(*xmax, *ymax, *zmin, *xmax, *ymin, *zmin, opcao);
    ArestaDoCubo(*xmax, *ymax, *zmin, *xmin, *ymax, *zmin, opcao);

    ArestaDoCubo(*xmin, *ymin, *zmax, *xmax, *ymin, *zmax, opcao);
    ArestaDoCubo(*xmin, *ymin, *zmax, *xmin, *ymax, *zmax, opcao);
    ArestaDoCubo(*xmax, *ymax, *zmax, *xmax, *ymin, *zmax, opcao);
    ArestaDoCubo(*xmax, *ymax, *zmax, *xmin, *ymax, *zmax, opcao);

    ArestaDoCubo(*xmin, *ymin, *zmin, *xmin, *ymin, *zmax, opcao);
    ArestaDoCubo(*xmax, *ymin, *zmin, *xmax, *ymin, *zmax, opcao);
    ArestaDoCubo(*xmin, *ymax, *zmin, *xmin, *ymax, *zmax, opcao);
    ArestaDoCubo(*xmax, *ymax, *zmin, *xmax, *ymax, *zmax, opcao);
  }

  quant = QuantasRegioes(arq_dados);
  for (i = quant - 1; i >= 0; i--) {
    LeRegiao(arq, i, &re);
    if (padrao1 >= 0) {
      if (re.cosN >= 0)
	Pintar(re.xq1, re.yq1, re.xq2, re.yq2, re.xq3, re.yq3,
		 re.xq4, re.yq4, cor_f1, cor_int1, cor_int2, padrao1);
      else
	Pintar(re.xq1, re.yq1, re.xq2, re.yq2, re.xq3, re.yq3,
		 re.xq4, re.yq4, cor_f2, cor_int3, cor_int4, padrao2);
    } else {
      if (re.cosN >= 0)
	Pintar2(re.xq1, re.yq1, re.xq2, re.yq2, re.xq3, re.yq3,
	 re.xq4, re.yq4, cor_f1, cor_int1, cor_int2, PADRAODECOR(re.cosN));
      else
	Pintar2(re.xq1, re.yq1, re.xq2, re.yq2, re.xq3, re.yq3,
	 re.xq4, re.yq4, cor_f2, cor_int3, cor_int4, PADRAODECOR(re.cosN));
    }
  }
  fclose(arq);

  if (opcao >= 0) {
    if (smax > s1 && smax > s5)
      ArestaDoCubo(*xmin, *ymin, *zmin, *xmax, *ymin, *zmin, opcao);
    if (smax > s1 && smax > s3)
      ArestaDoCubo(*xmin, *ymin, *zmin, *xmin, *ymax, *zmin, opcao);
    if (smax > s7 && smax > s5)
      ArestaDoCubo(*xmax, *ymax, *zmin, *xmax, *ymin, *zmin, opcao);
    if (smax > s7 && smax > s3)
      ArestaDoCubo(*xmax, *ymax, *zmin, *xmin, *ymax, *zmin, opcao);
    if (smax > s2 && smax > s6)
      ArestaDoCubo(*xmin, *ymin, *zmax, *xmax, *ymin, *zmax, opcao);
    if (smax > s2 && smax > s4)
      ArestaDoCubo(*xmin, *ymin, *zmax, *xmin, *ymax, *zmax, opcao);
    if (smax > s8 && smax > s6)
      ArestaDoCubo(*xmax, *ymax, *zmax, *xmax, *ymin, *zmax, opcao);
    if (smax > s8 && smax > s4)
      ArestaDoCubo(*xmax, *ymax, *zmax, *xmin, *ymax, *zmax, opcao);
    if (smax > s1 && smax > s2)
      ArestaDoCubo(*xmin, *ymin, *zmin, *xmin, *ymin, *zmax, opcao);
    if (smax > s5 && smax > s6)
      ArestaDoCubo(*xmax, *ymin, *zmin, *xmax, *ymin, *zmax, opcao);
    if (smax > s3 && smax > s4)
      ArestaDoCubo(*xmin, *ymax, *zmin, *xmin, *ymax, *zmax, opcao);
    if (smax > s7 && smax > s8)
      ArestaDoCubo(*xmax, *ymax, *zmin, *xmax, *ymax, *zmax, opcao);
  }

  SalvaConfiguracaoDoGrafico(NomeArquivo, cor_f1, cor_f2, cor_int1,  cor_int2,
   cor_int3, cor_int4, padrao1, padrao2, opcao, *xmin, *xmax, *ymin, *ymax,
   *zmax, *zmin, smax, s1, s2, s3, s4, s5, s6, s7, s8);

  return 1;
}

/* ------------------------------------------------------------------------- */

int Desenha2SuperficiesEsc(float (*f1) (float,float), float (*f2)(float, float),
  float (*f3)(float, float), float umin1, float umax1, float vmin1, float vmax1,
  int cor_f1_1, int cor_f2_1, int cor_int1_1, int cor_int2_1, int cor_int3_1,
  int cor_int4_1, int padrao1_1, int padrao2_1,
  float (*g1) (float,float), float (*g2)(float, float),
  float (*g3)(float, float), float umin2, float umax2, float vmin2, float vmax2,
  int cor_f1_2, int cor_f2_2, int cor_int1_2, int cor_int2_2, int cor_int3_2,
  int cor_int4_2, int padrao1_2, int padrao2_2, char *NomeArquivo, int opcao) {

/* Desenha as superficies (f1, f2, f3) e (g1, g2, g3), apagando as curvas
   invisiveis. */

  float u, v, xp1, yp1, zp1, xp2, yp2, zp2, xp3, yp3, zp3, xp4, yp4, zp4,
	X, Y, distancia, n1, n2, n3, xmin, xmax, ymin, ymax, zmax, zmin,
	smax, s1, s2, s3, s4, s5, s6, s7, s8;
  int k = 0, xq1, xq2, xq3, xq4, yq1, yq2, yq3, yq4;
  t_regiao re;
  long i, quant;
  FILE *arq;
  char arq_dados[80];

  strcpy(arq_dados, NomeArquivo);
  while(arq_dados[k] != '\0' && arq_dados[k] != '.') k++;
  arq_dados[k] = '\0';
  strcat(arq_dados, ".DAT");
  if ((arq = fopen(arq_dados, "wb")) == NULL) return -1;

  xmax = xmin = f1(umin1, vmin1);
  ymax = ymin = f2(umin1, vmin1);
  zmax = zmin = f3(umin1, vmin1);

  for (u = umin1 + (umax1 - umin1)/nu; u <= umax1 + (umax1 - umin1)/(2*nu);
					       u += (umax1 - umin1)/nu)
    for (v = vmin1 + (vmax1 - vmin1)/nv; v <= vmax1 + (vmax1 - vmin1)/(2*nv);
					       v += (vmax1 - vmin1)/nv) {
      xp1 = f1(u, v);
      yp1 = f2(u, v);
      zp1 = f3(u, v);
      if (xmax < xp1) xmax = xp1;
      if (xmin > xp1) xmin = xp1;
      if (ymax < yp1) ymax = yp1;
      if (ymin > yp1) ymin = yp1;
      if (zmax < zp1) zmax = zp1;
      if (zmin > zp1) zmin = zp1;

      xp2 = f1(u - (umax1 - umin1)/nu, v);
      yp2 = f2(u - (umax1 - umin1)/nu, v);
      zp2 = f3(u - (umax1 - umin1)/nu, v);
      if (xmax < xp2) xmax = xp2;
      if (xmin > xp2) xmin = xp2;
      if (ymax < yp2) ymax = yp2;
      if (ymin > yp2) ymin = yp2;
      if (zmax < zp2) zmax = zp2;
      if (zmin > zp2) zmin = zp2;

      xp3 = f1(u, v - (vmax1 - vmin1)/nv);
      yp3 = f2(u, v - (vmax1 - vmin1)/nv);
      zp3 = f3(u, v - (vmax1 - vmin1)/nv);
      if (xmax < xp3) xmax = xp3;
      if (xmin > xp3) xmin = xp3;
      if (ymax < yp3) ymax = yp3;
      if (ymin > yp3) ymin = yp3;
      if (zmax < zp3) zmax = zp3;
      if (zmin > zp3) zmin = zp3;

      xp4 = f1(u - (umax1 - umin1)/nu, v - (vmax1 - vmin1)/nv);
      yp4 = f2(u - (umax1 - umin1)/nu, v - (vmax1 - vmin1)/nv);
      zp4 = f3(u - (umax1 - umin1)/nu, v - (vmax1 - vmin1)/nv);
      if (xmax < xp4) xmax = xp4;
      if (xmin > xp4) xmin = xp4;
      if (ymax < yp4) ymax = yp4;
      if (ymin > yp4) ymin = yp4;
      if (zmax < zp4) zmax = zp4;
      if (zmin > zp4) zmin = zp4;

      ProjetaPonto(xp1, yp1, zp1, &X, &Y);
      xq1 = (int) (A + X*TAM); yq1 = (int) (B - Y*TAM);
      ProjetaPonto(xp2, yp2, zp2, &X, &Y);
      xq2 = (int) (A + X*TAM); yq2 = (int) (B - Y*TAM);
      ProjetaPonto(xp3, yp3, zp3, &X, &Y);
      xq3 = (int) (A + X*TAM); yq3 = (int) (B - Y*TAM);
      ProjetaPonto(xp4, yp4, zp4, &X, &Y);
      xq4 = (int) (A + X*TAM); yq4 = (int) (B - Y*TAM);

      FechoConvexo(&xq1, &yq1, &xq2, &yq2, &xq3, &yq3, &xq4, &yq4);
      distancia = DistanciaObs(xp1, yp1, zp1, xp2, yp2, zp2,
			       xp3, yp3, zp3, xp4, yp4, zp4);
      VetorNormal(&n1, &n2, &n3, f1, f2, f3, u - (umax1 - umin1)/(2*nu),
					     v - (vmax1 - vmin1)/(2*nv));
      re.cosN = (n1*o1 + n2*o2 + n3*o3)/NORMA(n1, n2, n3);

      re.d = distancia;
      re.xq1 = xq1;
      re.yq1 = yq1;
      re.xq2 = xq2;
      re.yq2 = yq2;
      re.xq3 = xq3;
      re.yq3 = yq3;
      re.xq4 = xq4;
      re.yq4 = yq4;
      re.n = 1;
      fwrite(&re, sizeof(t_regiao), 1, arq);
    }

  for (u = umin2 + (umax2 - umin2)/nu; u <= umax2 + (umax2 - umin2)/(2*nu);
						       u += (umax2 - umin2)/nu)
    for (v = vmin2 + (vmax2 - vmin2)/nv; v <= vmax2 + (vmax2 - vmin2)/(2*nv);
					       v += (vmax2 - vmin2)/nv) {
      xp1 = g1(u, v);
      yp1 = g2(u, v);
      zp1 = g3(u, v);
      if (xmax < xp1) xmax = xp1;
      if (xmin > xp1) xmin = xp1;
      if (ymax < yp1) ymax = yp1;
      if (ymin > yp1) ymin = yp1;
      if (zmax < zp1) zmax = zp1;
      if (zmin > zp1) zmin = zp1;

      xp2 = g1(u - (umax2 - umin2)/nu, v);
      yp2 = g2(u - (umax2 - umin2)/nu, v);
      zp2 = g3(u - (umax2 - umin2)/nu, v);
      if (xmax < xp2) xmax = xp2;
      if (xmin > xp2) xmin = xp2;
      if (ymax < yp2) ymax = yp2;
      if (ymin > yp2) ymin = yp2;
      if (zmax < zp2) zmax = zp2;
      if (zmin > zp2) zmin = zp2;

      xp3 = g1(u, v - (vmax2 - vmin2)/nv);
      yp3 = g2(u, v - (vmax2 - vmin2)/nv);
      zp3 = g3(u, v - (vmax2 - vmin2)/nv);
      if (xmax < xp3) xmax = xp3;
      if (xmin > xp3) xmin = xp3;
      if (ymax < yp3) ymax = yp3;
      if (ymin > yp3) ymin = yp3;
      if (zmax < zp3) zmax = zp3;
      if (zmin > zp3) zmin = zp3;

      xp4 = g1(u - (umax2 - umin2)/nu, v - (vmax2 - vmin2)/nv);
      yp4 = g2(u - (umax2 - umin2)/nu, v - (vmax2 - vmin2)/nv);
      zp4 = g3(u - (umax2 - umin2)/nu, v - (vmax2 - vmin2)/nv);
      if (xmax < xp4) xmax = xp4;
      if (xmin > xp4) xmin = xp4;
      if (ymax < yp4) ymax = yp4;
      if (ymin > yp4) ymin = yp4;
      if (zmax < zp4) zmax = zp4;
      if (zmin > zp4) zmin = zp4;

      ProjetaPonto(xp1, yp1, zp1, &X, &Y);
      xq1 = (int) (A + X*TAM); yq1 = (int) (B - Y*TAM);
      ProjetaPonto(xp2, yp2, zp2, &X, &Y);
      xq2 = (int) (A + X*TAM); yq2 = (int) (B - Y*TAM);
      ProjetaPonto(xp3, yp3, zp3, &X, &Y);
      xq3 = (int) (A + X*TAM); yq3 = (int) (B - Y*TAM);
      ProjetaPonto(xp4, yp4, zp4, &X, &Y);
      xq4 = (int) (A + X*TAM); yq4 = (int) (B - Y*TAM);

      FechoConvexo(&xq1, &yq1, &xq2, &yq2, &xq3, &yq3, &xq4, &yq4);
      distancia = DistanciaObs(xp1, yp1, zp1, xp2, yp2, zp2,
			       xp3, yp3, zp3, xp4, yp4, zp4);
      VetorNormal(&n1, &n2, &n3, g1, g2, g3, u - (umax2 - umin2)/(2*nu),
					     v - (vmax2 - vmin2)/(2*nv));
      re.cosN = (n1*o1 + n2*o2 + n3*o3)/NORMA(n1, n2, n3);

      re.d = distancia;
      re.xq1 = xq1;
      re.yq1 = yq1;
      re.xq2 = xq2;
      re.yq2 = yq2;
      re.xq3 = xq3;
      re.yq3 = yq3;
      re.xq4 = xq4;
      re.yq4 = yq4;
      re.n = 2;
      fwrite(&re, sizeof(t_regiao), 1, arq);
    }

  fclose(arq);

  if ((arq = fopen(arq_dados, "r+b")) == NULL) return -1;
  ClassificaRegioes(arq, arq_dados);

  smax = s1 = D_OBS(xmin, ymin, zmin);
  s2 = D_OBS(xmin, ymin, zmax);
  if (smax < s2) smax = s2;
  s3 = D_OBS(xmin, ymax, zmin);
  if (smax < s3) smax = s3;
  s4 = D_OBS(xmin, ymax, zmax);
  if (smax < s4) smax = s4;
  s5 = D_OBS(xmax, ymin, zmin);
  if (smax < s5) smax = s5;
  s6 = D_OBS(xmax, ymin, zmax);
  if (smax < s6) smax = s6;
  s7 = D_OBS(xmax, ymax, zmin);
  if (smax < s7) smax = s7;
  s8 = D_OBS(xmax, ymax, zmax);
  if (smax < s8) smax = s8;

  if (opcao >= 0) {
    ArestaDoCubo(xmin, ymin, zmin, xmax, ymin, zmin, opcao);
    ArestaDoCubo(xmin, ymin, zmin, xmin, ymax, zmin, opcao);
    ArestaDoCubo(xmax, ymax, zmin, xmax, ymin, zmin, opcao);
    ArestaDoCubo(xmax, ymax, zmin, xmin, ymax, zmin, opcao);

    ArestaDoCubo(xmin, ymin, zmax, xmax, ymin, zmax, opcao);
    ArestaDoCubo(xmin, ymin, zmax, xmin, ymax, zmax, opcao);
    ArestaDoCubo(xmax, ymax, zmax, xmax, ymin, zmax, opcao);
    ArestaDoCubo(xmax, ymax, zmax, xmin, ymax, zmax, opcao);

    ArestaDoCubo(xmin, ymin, zmin, xmin, ymin, zmax, opcao);
    ArestaDoCubo(xmax, ymin, zmin, xmax, ymin, zmax, opcao);
    ArestaDoCubo(xmin, ymax, zmin, xmin, ymax, zmax, opcao);
    ArestaDoCubo(xmax, ymax, zmin, xmax, ymax, zmax, opcao);
  }

  quant = QuantasRegioes(arq_dados);
  for (i = quant - 1; i >= 0; i--) {
    LeRegiao(arq, i, &re);
    if (padrao1_1 >= 0) {
      if (re.cosN >= 0) {
	if (re.n == 1)
	  Pintar(re.xq1, re.yq1, re.xq2, re.yq2, re.xq3, re.yq3,
		 re.xq4, re.yq4, cor_f1_1, cor_int1_1, cor_int2_1, padrao1_1);
	else
	  Pintar(re.xq1, re.yq1, re.xq2, re.yq2, re.xq3, re.yq3,
		 re.xq4, re.yq4, cor_f1_2, cor_int1_2, cor_int2_2, padrao1_2);
      } else {
	if (re.n == 1)
	  Pintar(re.xq1, re.yq1, re.xq2, re.yq2, re.xq3, re.yq3,
		 re.xq4, re.yq4, cor_f2_1, cor_int3_1, cor_int4_1, padrao2_1);
	else
	  Pintar(re.xq1, re.yq1, re.xq2, re.yq2, re.xq3, re.yq3,
		 re.xq4, re.yq4, cor_f2_2, cor_int3_2, cor_int4_2, padrao2_2);
      }
    } else {
      if (re.cosN >= 0) {
	if (re.n == 1)
	  Pintar2(re.xq1, re.yq1, re.xq2, re.yq2, re.xq3, re.yq3, re.xq4,
	  re.yq4, cor_f1_1, cor_int1_1, cor_int2_1, PADRAODECOR(re.cosN));
	else
	  Pintar2(re.xq1, re.yq1, re.xq2, re.yq2, re.xq3, re.yq3, re.xq4,
	  re.yq4, cor_f1_2, cor_int1_2, cor_int2_2, PADRAODECOR(re.cosN));

      } else {
	if (re.n == 1)
	  Pintar2(re.xq1, re.yq1, re.xq2, re.yq2, re.xq3, re.yq3, re.xq4,
	  re.yq4, cor_f2_1, cor_int3_1, cor_int4_1, PADRAODECOR(re.cosN));
	else
	  Pintar2(re.xq1, re.yq1, re.xq2, re.yq2, re.xq3, re.yq3, re.xq4,
	  re.yq4, cor_f2_2, cor_int3_2, cor_int4_2, PADRAODECOR(re.cosN));
      }
    }
  }
  fclose(arq);

  if (opcao >= 0) {
    if (smax > s1 && smax > s5)
      ArestaDoCubo(xmin, ymin, zmin, xmax, ymin, zmin, opcao);
    if (smax > s1 && smax > s3)
      ArestaDoCubo(xmin, ymin, zmin, xmin, ymax, zmin, opcao);
    if (smax > s7 && smax > s5)
      ArestaDoCubo(xmax, ymax, zmin, xmax, ymin, zmin, opcao);
    if (smax > s7 && smax > s3)
      ArestaDoCubo(xmax, ymax, zmin, xmin, ymax, zmin, opcao);
    if (smax > s2 && smax > s6)
      ArestaDoCubo(xmin, ymin, zmax, xmax, ymin, zmax, opcao);
    if (smax > s2 && smax > s4)
      ArestaDoCubo(xmin, ymin, zmax, xmin, ymax, zmax, opcao);
    if (smax > s8 && smax > s6)
      ArestaDoCubo(xmax, ymax, zmax, xmax, ymin, zmax, opcao);
    if (smax > s8 && smax > s4)
      ArestaDoCubo(xmax, ymax, zmax, xmin, ymax, zmax, opcao);
    if (smax > s1 && smax > s2)
      ArestaDoCubo(xmin, ymin, zmin, xmin, ymin, zmax, opcao);
    if (smax > s5 && smax > s6)
      ArestaDoCubo(xmax, ymin, zmin, xmax, ymin, zmax, opcao);
    if (smax > s3 && smax > s4)
      ArestaDoCubo(xmin, ymax, zmin, xmin, ymax, zmax, opcao);
    if (smax > s7 && smax > s8)
      ArestaDoCubo(xmax, ymax, zmin, xmax, ymax, zmax, opcao);
  }

  return 1;
}

/* ------------------------------------------------------------------------- */

/*** FIM DE ESCONDID.C ***/
